<template>
  <div class="button-container">
    <h3 class="title">{{title}}</h3>
    <div class="bg">
      <div :class="{filler: true, full}" :style="{transition: `all ${transitionTime}s`}"></div>
    </div>
  </div>
</template>

<script>
export default {
  name: "SlideButton",
  data() {
    return {
      full: false,
      setTimeoutCount: 0
    }
  },
  props: {
    title: {
      type: String,
      required: true
    },
    time: {
      type: Number,
      default: 5000
    },
    isAnimating: {
      type: Boolean,
      default: false
    },
    id: {
      type: Number,
      required: true
    }
  },
  methods: {
    start() {
      this.full = true;
      this.setTimeoutCount++;
      setTimeout(() => {
        if (this.isAnimating && this.setTimeoutCount === 1) {
          this.$emit("done", this.id);
        }
        this.setTimeoutCount--;
      }, this.time);
    }
  },
  watch: {
    isAnimating() {
      if (this.isAnimating) {
        this.start();
      } else {
        this.full = false;
      }
    }
  },
  computed: {
    transitionTime() {
      return this.isAnimating ? this.time / 1000 : 0;
    }
  },
  mounted() {
    if (this.isAnimating) {
      this.start();
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.button-container
  direction rtl
  &:hover
    cursor pointer

.title 
  font-weight 400
  font-size 1.6rem
  color $primary

.bg
  width 100%
  height .4rem
  margin-top $xsm
  background-color rgba($primary, .3)
  position relative

.filler
  width 0%
  height 100%
  position absolute
  top 0
  right 0
  background-color $primary
  &.full
    width 100%
</style>